;
$DATE (02.06.2005)
$TITLE (Test)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;************************************************************************
; Testprogramm fr Arithmetikroutinen
; J. Rathlev, Dez. 2003
;************************************************************************

      NAME      AriTest

;************************************************************************
; Konstanten
; ==========

CODEMEM EQU     000H

;************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

;************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

;************************************************************************
; Hauptprogramm

        ORG     CODEMEM+30H

$INCLUDE(AddSub16.a51)
$INCLUDE(MulDiv16.a51)
$INCLUDE(Sqrt.a51)


; Bytes umspeichern von Programmspeicher (DPTR) nach Datenspeicher (R0)
; MOVCD -  Anzahl der Bytes in R7
; MOVCD2 - 2 Bytes  (23s bei 12MHz)
MOVCD2: MOV     R7,#2
MOVCD:  CLR     A
        MOVC    A,@A+DPTR
        INC     DPTR
        MOV     @R0,A
        INC     R0
        DJNZ    R7,MOVCD
        RET


V1:     DB      0D2H,004H       ; = 1234 (Little-Endian-Format)
V2:     DB      02EH,016H       ; = 5678
V3:     DB      085H,01AH       ; = 6789
V4:     DB      0F1H,0B7H       ; = 47089
;V4:     DB      019H,03BH       ; = 15129

; Ergebnisse fr Testwerte:
;  V1+V2      =    6912 =     01B00H
; (V1+V2)-V3  =     123 =     0007BH
;  V1*V2      = 7006652 = 0006AE9BCH
; (V1*V2)/V3  =    1032 =     00408h

; Programmstart
Start:  MOV     SP,#STACKSTART

LOOP:
        MOV     DPTR,#V1
        MOV     R0,#SUM1
        CALL    MOVCD2
        MOV     DPTR,#V2       
        MOV     R0,#SUM2
        CALL    MOVCD2
        CALL    ADD16

        MOV     DPTR,#V3
        MOV     R0,#MINU
        CALL    MOVCD2
        CALL    SUB16

        MOV     DPTR,#V1
        MOV     R0,#FAK1
        CALL    MOVCD2
        MOV     DPTR,#V2
        MOV     R0,#FAK2
        CALL    MOVCD2
        CALL    MUL16

        MOV     DPTR,#V3
        MOV     R0,#DIVI
        CALL    MOVCD2
        CALL    DIV16

        MOV     DPTR,#V4
        MOV     R0,#RADI
        CALL    MOVCD2
        CALL    SQRT8

        SJMP    LOOP            ; Endlosschleife


;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; Stack: Rest des Datenspeichers

END
