;
$DATE (30.08.2004)
$TITLE (LCDTest)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;********************************************************************************************************
; Testprogramm fr LCD-Anzeige Typ 162
; J. Rathlev, Aug. 2004
;********************************************************************************************************

      NAME      LcdTest

;********************************************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H

LED     EQU     P1.5

;********************************************************************************************************
; Berechnung des Zhlerwertes:
;     N = 65536 - T/s * f/MHz / 12  

; f(Takt) = 24 MHz: 10 ms ==> 45536

; f(Takt) = 22,1184 MHz: 10 ms ==> 47104
 
 
TIMCNT  EQU     47104   ; Zhlerwert fr 10 ms bei 22,1184 MHz

T500MS  EQU     50      ; Anzahl der 10ms Takte fr 500 ms

;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

TCOUNT: DS      1               ; Zhler fr 10ms Takt
CCnt:   DS      1               ; Zhler (0 .. 9) auf Anzeige

;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

        ORG     CODEMEM+Timer0

        LJMP    T0IRQ


;********************************************************************************************************

        ORG     CODEMEM+30H

$INCLUDE(Display-162.a51)
$INCLUDE(Display.a51)

;********************************************************************************************************
; Timer 0 Interrupt
USING   2                       ; Registerbank 2 verwenden

T0IRQ:  PUSH    PSW
        PUSH    ACC
        MOV     PSW,#010H       ; Registerbank 2 einschal               aaaten

        MOV     TH0,#HIGH(TIMCNT)
        MOV     TL0,#LOW(TIMCNT)
        DJNZ    TCOUNT,T0RET    

        XRL     Line,#1
        MOV     A,Line
        CALL    SDLine

        MOV     DPTR,#Text
        CALL    WDStr

        MOV     A,CCnt
        XRL     A,#58
        JNZ     Out

        MOV     CCnt,#48
Out:    MOV     A,CCnt
        CALL    WDChar
        INC     CCnt

        MOV     TCOUNT,#T500MS

T0RET:  POP     ACC
        POP     PSW             ; Flags wiederherstellen 
        RETI
   
USING   0                       ; Registerbank 0 verwenden


;********************************************************************************************************
; Timer 0 initialisieren, Interrupts freischalten

InitTim:
        MOV     A,TMOD      
        ANL     A,#0F0H         ; Ausmaskieren von Timer 0 (Bit 0..3)
        ORL     A,#01H          ; Setze Mode 1, int. Zhltakt
        MOV     TMOD,A
        MOV     TH0,#HIGH(TIMCNT) ; Anfangswert fr 10 ms
        MOV     TL0,#LOW(TIMCNT)
        CLR     TF0
        MOV     TCOUNT,#T500MS  ; Wert fr 0,5 s
        SETB    TR0             ; Starte Timer
        SETB    ET0             ; Enable Timer-Interrupt
        SETB    EA              ; Enable Global-Interrupt
        RET


;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        CALL    InitDisplay
        MOV     Line,#1
        MOV     CCnt,#48        ; "0"
        CALL    InitTim         ; Timer initialisieren
        MOV     DPTR,#AuTab     ; zus. Zeichen definieren
        CALL    DefChar
        MOV     DPTR,#AdTab
        CALL    DefChar
LOOP:   
        SJMP    LOOP            ; Endlosschleife


TEXT:   DB      1,2,'Hallo: ',0;

;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; stack: rest of data memory

END
